#ifndef Joystick_h
#define Joystick_h

#define DIRECTINPUT_VERSION 0x0800

#include <dinput.h>
#include <stdio.h>

class Joystick {
public:
    Joystick();
    ~Joystick();

    // Initialize Joystick.  Joystick needs window handle for DirectInput
    bool Init(HWND hwnd);
    void Update();
    void GetPosition(double* position);

    // Effects
    void PlayBump(int wall);

    enum{WALL_LEFT, WALL_RIGHT, WALL_UP, WALL_DOWN};

protected:
    enum{AXIS_MIN = -1000};
    enum{AXIS_MAX = 1000};

    static LPDIRECTINPUT8 g_DirectInput;
    static LPDIRECTINPUTDEVICE8 m_Device;

    LPDIRECTINPUTEFFECT m_BumpEffect;
    DIJOYSTATE m_State;

    double pos[2];

    BOOL InitBumpEffect();
    HRESULT DoBumpEffect(int wall);

    static BOOL CALLBACK EnumJoysticksCallback(const DIDEVICEINSTANCE *pdidInstance, void *pContext);
    static BOOL CALLBACK EnumAxesCallback(LPCDIDEVICEOBJECTINSTANCE lpddoi, void *pvRef);
};

#endif