#include "KeyPlayer.h"
#include "config.h"
#include "inputSystem.h"

KeyPlayer::KeyPlayer(Maze* m) {
  maze = m;

  SetStartPosition();
  key = NO_KEY;
}

void KeyPlayer::Update(double elapsed) {
  double newPos[2];

  newPos[0] = pos[0];
  newPos[1] = pos[2];

  if (keyGetState(LEFT_ARROW)) newPos[0] += -config::movementScale*elapsed;
  if (keyGetState(UP_ARROW)) newPos[1] += -config::movementScale*elapsed;
  if (keyGetState(DOWN_ARROW)) newPos[1] += config::movementScale*elapsed;
  if (keyGetState(RIGHT_ARROW)) newPos[0] += config::movementScale*elapsed;

  tryToMove(newPos);

  key = NO_KEY;
}

void KeyPlayer::KeyPress(int lastKey) {
  key = lastKey;
}