#ifndef MazeGraphics_h
#define MazeGraphics_h

#include "glwrapper.h"
#include "maze.h"
#include "Player.h"

class MazeGraphics {
public:
    MazeGraphics();
    MazeGraphics(Maze* m, Player* p);
    virtual ~MazeGraphics();

    void Init();

    virtual void Update(double elapsed);

protected:
    Maze* maze;
    Player* player;

    GLuint mazeList;
    GLuint mazeStartList;
    GLuint mazeExitList;
    GLuint mazeFloorList;
    GLuint playerList;

    void CreateMazeList();
    void CreateMazeStartList();
    void CreateMazeExitList();
    void CreateMazeFloorList();
    void CreatePlayerList();

    void DrawGraphics();
};

#endif