#ifndef MazeGraphicsHaptics_h
#define MazeGraphicsHaptics_h

#ifdef PHANTOM_ENABLED
 #include <HL/hl.h>
 #include <HLU/hlu.h>
 #include <HDU/hduError.h>
#endif

#include "MazeGraphics.h"
#include "maze.h"
#include "Player.h"

#ifdef PHANTOM_ENABLED

class MazeGraphicsHaptics : public MazeGraphics {
public:
	MazeGraphicsHaptics(Maze* m, Player* p);
	~MazeGraphicsHaptics();

     void Update(double elapsed);

protected:
     GLuint constraintList;
     GLuint ceilingList;

     HLuint mazeListId;
     HLuint constraintListId;

    HLuint friction;

     bool atStart;

     void CreateConstraintList();

     void DrawHaptics();
     
     void UpdateWorkspace();
};

#endif

#endif