//////////////////////////////////////////////////////////////////////

#ifdef PHANTOM_ENABLED

//////////////////////////////////////////////////////////////////////

#include "Phantom.h"
#include "glwrapper.h"

//////////////////////////////////////////////////////////////////////

Phantom::Phantom() {
}

//////////////////////////////////////////////////////////////////////

Phantom::~Phantom() {
  printf("deleting Phantom (%x)\n", this);
  // Free up the haptic rendering context
    hlMakeCurrent(NULL);
    if (hHLRC != NULL)
    {
        hlDeleteContext(hHLRC);
    }

    // Free up the haptic device
    if (hHD != HD_INVALID_HANDLE)
    {
        hdDisableDevice(hHD);
    }
}

//////////////////////////////////////////////////////////////////////

bool Phantom::Init() {
     HDErrorInfo error;

     // Initialize the device befoer attempting to call any hd functions
     hHD = hdInitDevice(HD_DEFAULT_DEVICE);
     if (HD_DEVICE_ERROR(error = hdGetError())) {
          printf("No Phantom found.\n");
          return false;
     }

     hHLRC = hlCreateContext(hHD);
     hlMakeCurrent(hHLRC);

     // Enable optimization of the viewing parameters when rendering geometry
     hlEnable(HL_HAPTIC_CAMERA_VIEW);

     return true;
}

//////////////////////////////////////////////////////////////////////

void Phantom::Update() {
}

//////////////////////////////////////////////////////////////////////

void Phantom::GetPosition(double* pos) {
     hlGetDoublev(HL_PROXY_POSITION, pos);
}

//////////////////////////////////////////////////////////////////////

void Phantom::GetDevicePosition(double* pos) {
     hlGetDoublev(HL_DEVICE_POSITION, pos);
}

//////////////////////////////////////////////////////////////////////

#endif
