//////////////////////////////////////////////////////////////////////

#ifdef PHANTOM_ENABLED

//////////////////////////////////////////////////////////////////////

#include "PhantomPlayer.h"

//////////////////////////////////////////////////////////////////////

PhantomPlayer::PhantomPlayer(Maze* m) {
    maze = m;

    SetStartPosition();

    phantom = new Phantom();

    if (!phantom->Init()) {
         valid = false;
    }
}

//////////////////////////////////////////////////////////////////////

PhantomPlayer::~PhantomPlayer() {
    // Don't think we should have to check valid this, but we are...
    if (valid) {
        if (phantom) {
            delete phantom;
        }
    }
}

//////////////////////////////////////////////////////////////////////

void PhantomPlayer::Update(double elapsed) {
	// Get the device position for collision detection
	double devicePos[3];
	phantom->GetDevicePosition(devicePos);
	double testDevicePos[2];
	testDevicePos[0] = devicePos[0];
	testDevicePos[1] = devicePos[2];

    // Get the proxy position
    double playerPos[3];
    phantom->GetPosition(playerPos);
    double testPlayerPos[2];
	testPlayerPos[0] = playerPos[0];
	testPlayerPos[1] = playerPos[2];

    tryToMove(testDevicePos, testPlayerPos);
}

//////////////////////////////////////////////////////////////////////

#endif

//////////////////////////////////////////////////////////////////////
