#ifndef Player_h
#define Player_h

#include "Maze.h"
#include "sound.h"

static const double playerHeight = 0.25;

class Player {
protected:
    enum { ssNone, ssCenter, ssLeft, ssMiddle, ssRight } sweepState;
    double sweepTimer;

    SoundEntity * soundWallHit;
    SoundEntity * soundWalking;
    SoundEntity * sweepEmpty;
    SoundEntity * sweepFull;
    double pos[3];
    bool valid;
    bool mapFinished;

    void SetStartPosition();

    void hitWall(void);
    void tryToMove(double * newDevicePos, double * newPlayerPos);
    void tryToMove(double * newPos);

    Maze* maze;
    bool moving;
public:
    double vel[3];
    bool IsMoving(void) { return moving; }

    Player();
    ~Player();

    // Implement in derived classes
    virtual void Update(double elapsed) = 0;
    virtual void KeyPress(int key) = 0;
    bool IsValid();

    // Returns true if the player has finished the maze
    bool completedMaze() { return mapFinished; }

    void GetPosition(double* position);

    void caneSweep(double elapsed);
};

#endif