#ifndef CONFIG_HEADER_INCLUDE
#define CONFIG_HEADER_INCLUDE

#include "inputSystem.h"

namespace config {
  extern bool screenBlanked;

  // Display options
  static double verticalFOV = 60.0;    // in degrees

  // UI options
  static double keypressTimeout = 0.5; // in seconds
  static double idleTimeout = 15.0;     // in seconds, should be quite large

  static unsigned char zoneSayKey = ' ';
  static unsigned char skipKey = 'Z';
  //static unsigned char caneSweepKey = 'Z';
  static unsigned char exitKey = KEY_ESCAPE;
  static unsigned char screenBlankKey = 'B';

  // Physics options
  static double sweepInterval = 0.15;   // in seconds, a full sweep takes 4x this time (center-left-center-right-center)
  static double sweepWidth = 0.6;      // in squares (left to right ahead)
  static double sweepRange = 0.8;      // in squares (to center of tap region)

  static double movementScale = 1.5;   // in squares per second
  static double minVelocityForFeet = 0.003; // in squares per second
  static double maxTimestep = 0.9 / movementScale; // in seconds, mainly to prevent moving more than a square in a step

  // Joystick options
  static int forceFeedbackMagnitude = 8000;
  static int forceFeedbackGain = 8000;
  static int forceFeedbackDuration = 10000;
  static double joystickDeadZone = 0.001;

  // Phantom options
  static double phantomFrictionGain = 1.0;
  static double phantomFrictionMagnitude = 0.1;

  // Font options
  static double fontPitch = 10.0;
  static double fontWidth = 12.0;
  static double fontHeight = 16.0;
}

#endif
 