//////////////////////////////////////////////////////////////////////
// fonts.cpp - Font display wrapper //////////////////////////////////
//////////////////////////////////////////////////////////////////////

#ifndef FONTS_H
#define FONTS_H

//////////////////////////////////////////////////////////////////////
// Includes //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

#include "system.h"
#include "textures.h"

//////////////////////////////////////////////////////////////////////
// Constants /////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

#define CENTER_JUSTIFY -1
#define RIGHT_JUSTIFY -2
#define BOTTOM_JUSTIFY -2
#define TOP_JUSTIFY -3
#define LEFT_JUSTIFY -3

//////////////////////////////////////////////////////////////////////
// TFont /////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

class TFont {
protected:
  GLuint base;
  TTexture * fontTex;
  bool stateReady, fastDraw;
  void lockState(void);
  void unlockState(void);
public:
  int width;
  int height;

  TFont(const char * filename);
  virtual ~TFont();
  void drawText(GLint x, GLint y, int set, const char *fmt, ...);
  void drawTrueText(GLint x, GLint y, int set, const char *fmt, ...);
  void getTextExtents(const char * text, float * width, float * height);
  float getTextHeight(const char * text);
  float getTextWidth(const char * text);

  void lock(void);
  void unlock(void);
};

//////////////////////////////////////////////////////////////////////
// Ill-placed globals ////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

extern TFont * qfont;

//////////////////////////////////////////////////////////////////////

#endif

