//////////////////////////////////////////////////////////////////////

#ifndef INPUT_SYSTEM_H
#define INPUT_SYSTEM_H

//////////////////////////////////////////////////////////////////////

#include "system.h"

//////////////////////////////////////////////////////////////////////

// Call when a key is pressed (e.g. from OS message code)
void keyPressEvent(int key);

// Call when a key is released 
void keyReleaseEvent(int key);

// Returns the current state of the key
bool keyGetState(int key);

// Returns the current state of the key, and clears the key, so that
// it must be pressed again (or key-repeat'ed) before keyTriggered
// will again return true
bool keyTriggered(int key);

// Mouse position
extern float mouseX, mouseY, mouseZ;

#define LEFT_ARROW 0x25
#define UP_ARROW 0x26
#define RIGHT_ARROW 0x27
#define DOWN_ARROW 0x28
#define NO_KEY 0
#define KEY_ESCAPE 27

//////////////////////////////////////////////////////////////////////

#endif

//////////////////////////////////////////////////////////////////////
