//////////////////////////////////////////////////////////////////////

#include "jLists.h"

//////////////////////////////////////////////////////////////////////

int TStringList::IndexOf(char * st) {
  int Result = 0;
  TStringNode * iter = head;
  while (iter != NULL) {
    if (!j_stringCompare(iter->data, st, false, 0)) return Result;
    Result++;
    iter = iter->next;
  }
  return -1;
}

//////////////////////////////////////////////////////////////////////

char * TStringList::Items(int index) {
  TStringNode * iter = head;
  while (iter != NULL) {
    if (!index) return iter->data;
    iter = iter->next;
    index--;
  }
  return NULL;
}

//////////////////////////////////////////////////////////////////////

int TStringList::Count(void) {
  int Result = 0;
  TStringNode * iter = head;
  while (iter != NULL) {
    Result++;
    iter = iter->next;
  }
  return Result;
}

//////////////////////////////////////////////////////////////////////

void TStringList::Add(char * st) {
  TStringNode * last, * cur;
  last = cur = head;
  while (cur != NULL) {
    last = cur;
    cur = cur->next;
  }
  cur = new TStringNode;
  int length = j_stringLength(st);
  cur->data = new char[length+1];
  j_stringCopy(st, cur->data, length);
  cur->data[length] = 0;
  cur->next = NULL;
  if (head != NULL) last->next = cur; else head = cur;
}

//////////////////////////////////////////////////////////////////////

TStringList::TStringList(void) {
  head = NULL;  
}

//////////////////////////////////////////////////////////////////////

TStringList::~TStringList(void) {
  TStringNode * next = head;
  while (next != NULL) {
    next = head->next;
    delete [] head->data;
    delete head;
    head = next;
  }
  head = NULL;
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

int TList::Count(void) {
  int Result = 0;
  TListNode * iter = head;
  while (iter != NULL) {
    Result++;
    iter = iter->next;
  }
  return Result;
}

//////////////////////////////////////////////////////////////////////

void * TList::Items(int index) {
  TListNode * iter = head;
  while (iter != NULL) {
    if (!index) return iter->data;
    iter = iter->next;
    index--;
  }
  return NULL;
}

//////////////////////////////////////////////////////////////////////

void TList::Add(void * item) {
  TListNode * last, * cur;
  last = cur = head;
  while (cur != NULL) {
    last = cur;
    cur = cur->next;
  }
  cur = new TListNode;
  cur->data = item;
  cur->next = NULL;
  if (head != NULL) last->next = cur; else head = cur;
}

//////////////////////////////////////////////////////////////////////

TList::TList(void) {
  head = NULL;
}

//////////////////////////////////////////////////////////////////////

TList::~TList(void) {
  TListNode * next = head;
  while (next != NULL) {
    next = head->next;
    delete head;
    head = next;
  }
  head = NULL;
}

//////////////////////////////////////////////////////////////////////
