//////////////////////////////////////////////////////////////////////

#include "system.h"
#include "jmath.h"

//////////////////////////////////////////////////////////////////////

// Fixme: remove it
#include <math.h>
#include <stdlib.h>

//////////////////////////////////////////////////////////////////////

float j_arctan2(float x, float y) {
  if (fabs(x) < EPSILON) {
    if (fabs(y) < EPSILON) {
      return(0.0);
    } else if (y > 0.0) {
      return HALF_PI;  /*(pi*0.5);*/
    } else {
      return THREE_HALVES_PI;  /*(pi*1.5);*/
    }
  } else if (x < 0.0) {
    return (j_atan(y/x) + PI);
  } else {
    return (j_atan(y/x)); 
  }
}

//////////////////////////////////////////////////////////////////////

double j_power(double f, double p) {
  int s;
  double a;
  
  s = (f < 0 ? -1 : 1);
  a = (f < 0 ? -f : f);

  if (a < 0.00001)
    return (0.0);
  else
    return (s * j_pow(a, p));
}

//////////////////////////////////////////////////////////////////////

unsigned current_rnd = 777;
#define EPSI 1.52590218966964e-5 /* 1 / ((2^16) - 1) */

double ra2d(void) {
  static unsigned long rnd_a = 293, rnd_c = 57111, mask = 65535;
  current_rnd = (unsigned) ((((unsigned long) current_rnd) * rnd_a + rnd_c) & mask);
  return (((double) current_rnd) * EPSI);
}

//////////////////////////////////////////////////////////////////////

float j_random(float bias, float range) {
  return bias + range * ra2d();//((rand()%10000) * (1.0f / 10000.0f));
}

//////////////////////////////////////////////////////////////////////

// Returns true if x is a power of 2
bool isPowerOf2(int x) {
  return (x > 0) && ((x & (x - 1)) == 0);
}

//////////////////////////////////////////////////////////////////////

int nextPowerOf2(int x) {
  int result = 1;
  while (result < x) result <<= 1;
  return result;
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_sqrt(double f) {
  return sqrt(f);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_cos(double d) {
  return cos(d);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_sin(double d) {
  return sin(d);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_tan(double a) {
  return tan(a);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_atan(double a) {
  return atan(a);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_atan2(double d, double b) {
  return atan2(d, b);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_asin(double d) {
  return asin(d);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_acos(double d) {
  return acos(d);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_pow(double d, double e) {
  return pow(d, e);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_abs(double d) {
  return fabs(d);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_exp(double d) {
  return exp(d);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_mod(double a, double b) {
  return fmod(a, b);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_floor(double a) {
  return floor(a);
}

//////////////////////////////////////////////////////////////////////

double __stdcall j_ceil(double a) {
  return floor(a);
}

//////////////////////////////////////////////////////////////////////

int j_irand(void) {
  return rand();
}

//////////////////////////////////////////////////////////////////////