//////////////////////////////////////////////////////////////////////

#ifndef JMATH_H
#define JMATH_H

//////////////////////////////////////////////////////////////////////

#define TWO_PI  6.283185307179f  // 2 pi
#define SINP    (-0.25f*TWO_PI)     // -pi/2
#define PI      (0.5f*TWO_PI)
#define HALF_PI (0.25f*TWO_PI)
#define PIOSIX  (TWO_PI*(1.0f/12.0f))
#define M_PI    3.141592653589f
#define THREE_HALVES_PI 4.712388980f

#define EPSILON 1E-8
#define EPSILONF 1E-8f

//////////////////////////////////////////////////////////////////////

#ifndef min
#define min(a, b) ((a) < (b) ? (a) : (b))
#endif

#ifndef max
#define max(a, b) ((a) > (b) ? (a) : (b))
#endif

#ifndef sqr
#define sqr(a) ((a) * (a))
#endif

//#define sign(a) ((a) > 0 ? 1 : (((a) == 0) ? 0 : -1))

//////////////////////////////////////////////////////////////////////

float j_arctan2(float x, float y);
double j_power(double f, double p);
#define j_powerf(f, p) ((float)j_power(f, p))

float j_random(float bias, float range);
bool isPowerOf2(int x);
int nextPowerOf2(int x);

//////////////////////////////////////////////////////////////////////

double __stdcall j_sqrt(double f);
double __stdcall j_cos(double d);
double __stdcall j_sin(double d);
double __stdcall j_tan(double a);
double __stdcall j_atan(double a);
double __stdcall j_atan2(double d, double b);
double __stdcall j_asin(double d);
double __stdcall j_acos(double d);
double __stdcall j_pow(double d, double e);
double __stdcall j_abs(double d);
double __stdcall j_exp(double d);
double __stdcall j_mod(double a, double b);
double __stdcall j_floor(double a);
double __stdcall j_ceil(double a);
//long _declspec () _ftol ();

int j_irand(void);

//////////////////////////////////////////////////////////////////////

#endif

//////////////////////////////////////////////////////////////////////
