//maze.h

#ifndef maze_h
#define maze_h

#include "cell.h"
#include "zone.h"
#include "SoundEntity.h"
#include <vector>
#include <string>
#include <fstream>
#include <vector>
#include <iostream>

class Maze {

private:
  float cellSize;
  int height;
  int width;
  //typedef std::vector <Cell *> row;
  //std::vector <row> maze;
  typedef Cell * PCell;
  PCell * maze;
  bool isAllowed(char c);

  std::vector <Zone *> zones;
  std::vector <SoundEntity *> sounds;

public:
  std::string description;

  ~Maze();
  Maze(std::string file);
  int getHeight();
  int getWidth();
  void init (int width, int height);
  Cell * getCell(int x, int y);

  Zone * getZone(int x, int y);
  Zone * getZone(double * pos) { return getZone((int)pos[0], (int)pos[2]); }
  void getStart(double* start);

  bool validMove(double* pos);

  float getCellSize ();
  void setCellSize (float size);

  // Hacksville
  bool isExit(double * pos);
  bool isEntrance(double * pos);
};

#endif