#ifndef SPEECH_HEADER_INCLUDE
#define SPEECH_HEADER_INCLUDE

//////////////////////////////////////////////////////////////////////

typedef void * SpeechToken;

//////////////////////////////////////////////////////////////////////

// Creates a new speech event using the text passed in
// text is first treated as a filename, by appending .wav and .mp3,
// and if that fails, it is treated as text for a TTS engine
SpeechToken startSpeechEvent(const char * text);

// kills the speech event represented by the token (or fails silently
// if that speech event has already been completed)
void stopSpeechEvent(SpeechToken token);

// called when someone hits CTRL or similar, kills all speech
void stopSpeechEvents(void);

// should be called once a frame or once a second or so, cleans up
// resources used by the speech system, because I'm too lazy to
// setup callbacks for fmod and TTS
void pollSpeechEvents(void);


void stopOneSpeechEvent(void);
//////////////////////////////////////////////////////////////////////

void speechInit(void);
void speechCleanup(void);

//////////////////////////////////////////////////////////////////////

#endif
