//////////////////////////////////////////////////////////////////////

#ifndef __vfs_win32__
#define __vfs_win32__

//////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "system.h"
#include "jfilesystem.h"

//////////////////////////////////////////////////////////////////////

class TVFSMountWin32 : public TVFSMount {
 public:
  TVFSMountWin32(const char * root);// override;
  ~TVFSMountWin32(void); // override;

  virtual TVFSStream * fsFileOpen(const char * FileName, TVFSFileMode Mode); // override;
  virtual void fsListFiles(const char * Path, TStringList * list);// override;

  virtual bool fsFileExists(const char * FileName);// override;
 private:
   char * FRoot;
};

//////////////////////////////////////////////////////////////////////

class TVFSStreamWin32 : public TVFSStream {
 private:
  HANDLE FHandle;
 public:
  TVFSStreamWin32(const char * FileName, int Mode);
  ~TVFSStreamWin32(void);

  virtual int Read(void * buffer, int count);
  virtual int Write(const void * buffer, int count);
  virtual int Seek(int offset, TVFSOrigin origin);
  virtual bool setSize(int newSize);
};

bool FileExists(const char * FileName);

//////////////////////////////////////////////////////////////////////

#endif

//////////////////////////////////////////////////////////////////////
