//////////////////////////////////////////////////////////////////////

#ifndef VFS_ZIP_FILE
#define VFS_ZIP_FILE

//////////////////////////////////////////////////////////////////////

#include "system.h"
#include "jfilesystem.h"

//////////////////////////////////////////////////////////////////////

class TVFSMountZip : public TVFSMount {
 public:
  TVFSMountZip(const char * root);
  ~TVFSMountZip(void);

  virtual TVFSStream * fsFileOpen(const char * FileName, TVFSFileMode Mode);
  virtual void fsListFiles(const char * Path, TStringList * list);

  virtual bool fsFileExists(const char * FileName);
 private:
  void * FZipFile;
};

//////////////////////////////////////////////////////////////////////

class TVFSStreamZip : public TVFSStream {
 private:
  int FLength;
  int FPointer;
  void * FBuffer;
 public:
  TVFSStreamZip(void * zip);
  ~TVFSStreamZip(void);

  virtual int Read(void * buffer, int count);
  virtual int Write(const void * buffer, int count);
  virtual int Seek(int offset, TVFSOrigin origin);
  virtual bool setSize(int newSize);
};

//////////////////////////////////////////////////////////////////////

#endif

//////////////////////////////////////////////////////////////////////
