//////////////////////////////////////////////////////////////////////

#ifndef VIEWPOINT_H
#define VIEWPOINT_H

//////////////////////////////////////////////////////////////////////

#include "system.h"

//////////////////////////////////////////////////////////////////////

class TViewpoint {
public:
  float pos[3];
  float theta, phi;

  float FFocalLength;
  float FElevation;
  float FFlyback;
  bool FRotate;

    // Property accessors
  float getFocalLength(void) { return FFocalLength; }
  float getElevation(void) { return FElevation; }
  float getFlyback(void) { return FFlyback; }

  void setFocalLength(float focalLength) { FFocalLength = focalLength; }
  void setElevation(float elevation) { FElevation = elevation; }
  void setFlyback(float flyback) { FFlyback = flyback; }

  void dontRotate(void) { FRotate = false; }

  void setPosition(int left, int top);
  void setDimensions(int width, int height);

  // Modes
  void renderMode2D(void);
  void renderMode3D(float nearDistance, float farDistance);

  // Activators
  void lookat(void);
  void lookOnly(void);
  void lookAtObject(void);
private:
  int something;
  int myLeft;
  int myTop;
  int myWidth;
  int myHeight;
};

//////////////////////////////////////////////////////////////////////

class TRenderObject : public TJObject {
public:
  // context holds the render context
  // elapsed holds the number of frame units since the last call (1/60th of a second)
  virtual void render(TViewpoint * context, float elapsed) {
    j_printf("Error: TRenderObject::render does sweet FA, descendants should reimplement\n");
  }
};

//////////////////////////////////////////////////////////////////////

#endif

//////////////////////////////////////////////////////////////////////
