//////////////////////////////////////////////////////////////////////
unit NewMapForm; /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
interface ////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, Math;

//////////////////////////////////////////////////////////////////////

type
  TNewMapDialog = class(TForm)
    mapWidth: TEdit;
    mapHeight: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    mapCellSize: TEdit;
    Label3: TLabel;
    bDone: TButton;
    bCancel: TButton;
    procedure bDoneClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    outWidth, outHeight: integer;
    outCellSize: single;
  end;

//////////////////////////////////////////////////////////////////////

var
  NewMapDialog: TNewMapDialog;

//////////////////////////////////////////////////////////////////////
implementation ///////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

{$R *.DFM}

//////////////////////////////////////////////////////////////////////

procedure TNewMapDialog.bDoneClick(Sender: TObject);
var
  t: integer;
  f: single;
begin
  t := StrToIntDef(mapWidth.Text, -1);
  if t < 1 then begin
    ShowMessage('The map width must be a positive integer (e.g. 16 or 24)');
    Exit;
  end;
  outWidth := t;

  t := StrToIntDef(mapHeight.Text, -1);
  if t < 1 then begin
    ShowMessage('The map height must be a positive integer (e.g. 16 or 24)');
    Exit;
  end;
  outHeight := t;

  f := -1.0;
  try
    f := StrToFloat(mapCellSize.Text);
  except
    on e: EConvertError do ;
  end;
  if f < 0.0001 then begin
    ShowMessage('The cell size must be a positive number (e.g. 0.1 or 1.0)');
    Exit;
  end;
  outCellSize := f;

  ModalResult := mrOk;
end;

//////////////////////////////////////////////////////////////////////

end.

//////////////////////////////////////////////////////////////////////

