//////////////////////////////////////////////////////////////////////
unit objUtils; ///////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
interface ////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

uses
  Math;

//////////////////////////////////////////////////////////////////////

type
  TBoundingBox = record
    mins: array[0..2] of single;
    maxs: array[0..2] of single;
  end;

//////////////////////////////////////////////////////////////////////

procedure objComputeBB(const filename: string; var box: TBoundingBox);

//////////////////////////////////////////////////////////////////////
implementation ///////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

procedure objComputeBB(const filename: string; var box: TBoundingBox);
var
  fp: TextFile;
//  line: string;
  cmd: string;
  f: single;
  i: integer;
begin
  AssignFile(fp, filename);
  Reset(fp);
  box.mins[0] := 1e6;
  box.mins[1] := 1e6;
  box.mins[2] := 1e6;
  box.maxs[0] := -1e6;
  box.maxs[0] := -1e6;
  box.maxs[0] := -1e6;

  while not Eof(fp) do begin
    Read(fp, cmd);
    if cmd = 'v' then begin
      for i := 0 to 2 do begin
        Read(fp, f);
        box.mins[i] := Min(box.mins[i], f);
        box.maxs[i] := Max(box.maxs[i], f);
      end;
    end;
    ReadLn(fp);
  end;
  CloseFile(fp);
end;

//////////////////////////////////////////////////////////////////////

end.

//////////////////////////////////////////////////////////////////////

