//////////////////////////////////////////////////////////////////////
unit soundEditor; ////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
interface ////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, mazeTypes;

//////////////////////////////////////////////////////////////////////

type
  TSoundEditFrame = class(TFrame)
    ex: TEdit;
    ez: TEdit;
    ey: TEdit;
    efilename: TEdit;
    eradius: TEdit;
    ecutoff: TEdit;
    rbtriggered: TRadioButton;
    rbloop: TRadioButton;
    lSoundfile: TLabel;
    cbSurround: TCheckBox;
    bPickFile: TButton;
    lPosition: TLabel;
    lCutoff: TLabel;
    lTriggerSize: TLabel;
    evolume: TEdit;
    lVolume: TLabel;
    OpenDialog: TOpenDialog;
    procedure bPickFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    sound: TMazeSound;
    procedure SetSound(source: TMazeSound);
    function GetSound: TMazeSound;
  end;

//////////////////////////////////////////////////////////////////////
implementation ///////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

{$R *.DFM}

//////////////////////////////////////////////////////////////////////
// TSoundEditFrame ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

procedure TSoundEditFrame.SetSound(source: TMazeSound);
begin
  sound := source;
{  if not Assigned(backup) then sound := TMazeSound.Create;
  if not Assigned(sound) then sound := TMazeSound.Create;
  sound.Assign(source);}

  efilename.Text := sound.filename;

  cbSurround.Checked := false; // fixme

  if sound.triggered then
    rbTriggered.Checked := true
  else
    rbLoop.Checked := true;

  ex.Text := FloatToStr(sound.x);
  ey.Text := FloatToStr(sound.y);
  ez.Text := FloatToStr(sound.z);
  evolume.Text := FloatToStr(sound.volume);
  ecutoff.Text := FloatToStr(sound.cutoff);
  eradius.Text := FloatToStr(sound.radius);
end;

//////////////////////////////////////////////////////////////////////

procedure TSoundEditFrame.bPickFileClick(Sender: TObject);
var
  base: string;
  i: integer;
begin
  if OpenDialog.Execute then begin
     base := ExtractFilePath(OpenDialog.Filename);
     i := Pos('base', base);
     if i > -1 then begin
       i := i + 4 + 1;
       Delete(base, i, Length(base)-i+1);
     end; 
     efilename.Text := ExtractRelativePath(base, OpenDialog.Filename);
  end;
end;

//////////////////////////////////////////////////////////////////////

function FloatToStrDef(st: string; default: single): single;
begin
  Result := default;
  try
    Result := StrToFloat(st);
  except
    on e: EConvertError do e.Free;
  end;
end;

//////////////////////////////////////////////////////////////////////

function TSoundEditFrame.GetSound: TMazeSound;
var
  dest: TMazeSound;
begin
  dest := TMazeSound.Create;
  dest.filename := efilename.Text;

  dest.triggered := rbTriggered.Checked;
  dest.x := FloatToStrDef(ex.Text, sound.x);
  dest.y := FloatToStrDef(ey.Text, sound.y);
  dest.z := FloatToStrDef(ez.Text, sound.z);

  dest.volume := FloatToStrDef(evolume.Text, sound.volume);
  dest.cutoff := FloatToStrDef(ecutoff.Text, sound.cutoff);
  dest.radius := FloatToStrDef(eradius.Text, sound.radius);

  Result := dest;
end;

//////////////////////////////////////////////////////////////////////

end.

//////////////////////////////////////////////////////////////////////

